Not emulating Crash that occurs on console (metroid prime 2)

08/16/2018 02:39 PM - mr_whiskers

Status: Accepted % Done: 0%

Priority: Normal   

Assignee:    

Category:    

Target version:    

Operating system: N/A Relates to

performance:

No

Issue type: Bug Easy: No

Milestone:  Relates to

maintainability:

No

Regression: No Regression start:  

Relates to usability: No Fixed in:  

Description

Game Name?

Metroid Prime 2: Echoes

Game ID? (right click the game in the game list, properties, info tab)

G2ME01

MD5 Hash? (right click the game in the game list, properties, info tab, MD5 Hash: Compute)

ce781ad1452311ca86667cf8dbd7d112

What's the problem? Describe what went wrong.

On console the game will crash in 2 spots that it will not crash on dolphin.

What steps will reproduce the problem?

Description in video. Hard to setup. Go to reactor core in dark aether of sanctuary fortress. Have the game map say youre on the

savestation while youre around the corner in reactor core. look at my specific spot in the video and morph and hold upleft (might be

slightly off angle) to get infinite speed. Infinite speed is the morph ball with no shell. In the rest of the video 1 the game should crash

wehn the ing guardians (black goop looking things) touch you with infinite speed. 2 the end of the video I boost into a wall and my

shell reappears. The game would not give you your shell back normally in any scenario like that and crashes there 100% of the time. 

Is the issue present in the latest development version? For future reference, please also write down the version number of

the latest development version.

5.0-8594

Is the issue present in the latest stable version?

yes 5.0-8594

If the issue isn't present in the latest stable version, which is the first broken version? (You can find the first broken version by

bisecting. Windows users can use the tool 

https://forums.dolphin-emu.org/Thread-green-notice-development-thread-unofficial-dolphin-bisection-tool-for-finding-broken-builds

and anyone who is building Dolphin on their own can use git bisect.)

n/a

If your issue is a graphical issue, please attach screenshots and record a three frame fifolog of the issue if possible. 

Screenshots showing what it is supposed to look like from either console or older builds of Dolphin will help too.  For more
information on how to use the fifoplayer, please check here: https://wiki.dolphin-emu.org/index.php?title=FifoPlayer

not going to mention the graphical issues here (this trick is supposed to cause a huge graphical lightshow but on dolphin results in a

black screen always.)

What are your PC specifications? (CPU, GPU, Operating System, more)

i7-7700k overclocked, gtx 1060 6gb, windows 10, 16 gb ram

Is there anything else that can help developers narrow down the issue? (e.g. logs, screenshots,

configuration files, savefiles, savestates)

attached is a download link to my drive for the savestate to immediately try the trick and also a save file at the same room to load to

try the trick on any build of dolphin or version of the game (assuming you can set the trick up ). also attached is my video of the trick

so you can see the 2 spots it should crash and doesnt. the video is unlisted you need this link to see it.

https://youtu.be/ndw9rPJrBgQ

https://drive.google.com/open?id=1w2VTLMTzhdtgydMkD2zVRoHS4Cmo4W25

History

#1 - 08/16/2018 04:34 PM - JMC4789

There are some features that may be able to help with something like this.  You may want to enable FPRF and AccurateNANs and whatnot - which

are mostly hidden as they don't provide a benefit in most games.  If MMU emulation isn't enabled (it should be by default in the latest builds,) then you

should enable that as well.

AccurateNANs doesn't have an option anywhere in the GUI.

#2 - 12/27/2018 10:28 PM - JMC4789

- Status changed from New to Questionable

Rather than a savestate, would you mind putting a save (and any extra instructions to get to the area) in this issue?  I'm genuinely interested but

Dolphin is no longer compatible with the savestate you posted.

Marking as questionable if only because we don't have a good status for waiting for reply.

#3 - 01/14/2019 10:00 PM - mr_whiskers

hello, sorry it has taken me a while to get back to you. Attached orginally is the google drive download link that I believe contains the savestate and

the save file as well. As for "FPRF and AccurateNANs" and MMU that you mentioned in the reply previously to this, I know for sure MMU was enabled

on my build by default and I dont believe I did anything with AccurateNANs and FPRF. Its unfortunate that the savestate will no longer work for you

the setup to get the infinite speed trick you see here is pretty precise. The youtube video linked also contains a description for the setup used to get

the trick. Hopefully you are still interested in it, thanks let me know anything I can do to help! 

#4 - 01/14/2019 10:04 PM - JMC4789

I honestly believe this is probably an issue with Dolphin.  The problem is that it's so hard to reproduce that probably only experienced runners of  teh

game would be able to consistently do it.

#5 - 01/14/2019 10:17 PM - mr_whiskers

I would be more than happy to download a new build of dolphin to make you a savestate before the crash if you can provide me with a build.
#6 - 01/14/2019 10:28 PM - JMC4789

The problem is that eventually it'll just... not work anymore.  If you can do the latest dev build, I can give it a shot though.  Please mark what revision

the savestate was made for future reference so if a dev later on more skilled than me can look at it, they can find out what build was used.  You did

this with the earlier savestate, so, it shouldn't be an issue.

#7 - 01/14/2019 10:34 PM - mr_whiskers

I understand that with each new build the savestate won't work and I am more than willing to keep making new savestates on whatever build you

guys want if you're willing to keep looking at it. Making this emulate properly would do wonders for our community and I am happy to help you guys in

whatever way to keep trying to fix the issue. Latest dev build I see is 5.0-9335 would this be the version you want me to make a savestate on? 

#8 - 01/14/2019 10:35 PM - JMC4789

- Status changed from Questionable to Accepted

Do we know why it crashes on console?

#9 - 01/14/2019 10:46 PM - mr_whiskers

I have talked about it in speculation with one of our modders/programmer/reverse-engineering the game guys. I can't really say for the first crash we

didn't talk about it. Generally from what I understand about this trick, what is happening is that you have NaN speed and when you use boost ball it

tries to add some x value to NaN which can result for a frame in NaN position. NaN position is handled by the game interesting so it more or less is

checking to see your position relative to other positions. So having NaN (not completely accurate statement here) will result in the game checking

your position against nearly every other thing loaded currently. So this lets us pick up items through walls but we also take damage and touch

cutscene triggers and things. For the end of the video he speculates that its supposed to crash usually because of loading something or touching a

cutscene. Having tested on a few versions of dolphin I know it probably isn't loading or touching cutscenes so my theory is that it is crashing because

of checking your position relative to too many things. I don't have the most in depth knowledge of RAM for the game or anything but I do know the

game has designated caches for specific types of ram like you can only have so many rooms of x size loaded in the cache corresponding to that size

room. So my theory is that you are checking your position against the like 20 enemies floating around plus like 6 respawn triggers a bunch of walls the

room is super huge and a few objects and actors in the room too. So maybe youre overflowing wherever the game is storing that ram? As for the first

crash, they might be trying to slow your speed down and trying to subtract speed or something from your NaN rotational speed which could be whats

causing a crash I am not entirely sure. 

#10 - 01/14/2019 10:49 PM - JMC4789

Try enabling accurateNaNs in Dolphin's configuration file.

#11 - 01/14/2019 10:56 PM - mr_whiskers

im not sure how to do that could you talk me through it 

#12 - 01/14/2019 10:59 PM - JMC4789

In Dolphin.ini (in a portable build, located in the User/Config Folder) make sure to set these two options from False to True.

FPRF = True

AccurateNaNs = True

#13 - 01/14/2019 11:08 PM - mr_whiskers

05/05/2021 3/4



I updated my build to 5.0-9335 and enabled FPRF and accurateNans. It will take me a little while to get myself back to that spot to try to re-create the

crash now need to use some mods and things I will let you know when I'm back there and have tested it. 

#14 - 01/14/2019 11:46 PM - mr_whiskers

okay yeah that was not correct at all lmao definitely something emulation issue happening here this is less accurate than a 5.8.7 FM build i use for

practice usually. I can record a short video if you would like but essentially, it gave me my shell back which can never happen in game, then when

unmorphing I got the correct visual effects that would typically happen with this trick. Its worth noting that previously having only switched to the

5.0-8594 build I started earlier that when unmorphing you would not get the correct visual effect (called lightshow). On dolphin (people in the

community have had conversations and reported it before which is why I didn't discuss it) the screen turns black simply but on console you have

flashing triangles and shit all over the screen behind your hud. having a black screen is fine tho thats still at least what i want or good enough. the

game giving me my shell back, is terrible news thats legit impossible in game can never happen on console, but giving me at least a expected

damage value is good news. it didn't crash on the other part it should where you get swallowed by the ing (goop looking things) not recorded. 

https://youtu.be/eSSviQgakqk

#15 - 01/14/2019 11:53 PM - JMC4789

We're definitely not less accurate than the shitty Faster Melee builds based off Ishiiruka XD. If anything, different emulation of the underlying

behaviors is causing different things to happen.  We don't know exactly what's happening though.  Nothing significant has changed in terms of internal

emulation of something like this recently, so, maybe accuratenans is causing different behavior?  Do either of those options affect this at all?

#16 - 01/15/2019 12:02 AM - mr_whiskers

sorry didnt mean to make the Ishiiruka build sound good its not lol, just noting that the 5.8.7 FM doesnt have MMU on and when i turned it on is when

the morph ball started to not act correct and the shell would re appear not sure if that is 100% related or just correlation. And the other thing worth

noting is something between 8594 and the 9335 that I am running now at least fixed the unmorph ligthshow (where it attempts to render the camera

at NaN). I can run it again with any settings enabled or disabled and tell you the results if you would like just let me know what you would like to

change and ill change it and check :) 
